Rem $Title:    'Perpetual Inventory System. Reports and Closing.'
Rem $Page
HouseKp: Cls
         Width "Lpt1:",132
         Lprint chr$(027);chr$(048);chr$(027);chr$(15);
         ZO$   = Mki$(0)
         M3    = 50
         M1    = 200
         Dim   I1$(M1),R1(M1),U$(12),U(12)
         Color 10
         Print "Enter Inventory File Name ";
         Color 15
         Input F$
         D1$   = Date$
         GoSub OpenF
Main:    Cls
         Color 10
         Print "The Following Options are Available:"
         Color 15
         Print
         Print Tab(5);"1..File List"
         Print Tab(5);"2..Usage Report"
         Print Tab(5);"3..Inventory Status Report"
         Print Tab(5);"4..End of Month Close Accounts"
         Print Tab(5);"5..Save Copy of Inventory File"
         Print Tab(5);"6..Inventory Analysis Report (Weighted Average)"
         Print Tab(5);"7..Update Program"
         Print
         O1$ = ""
         Color 10: Print "Enter Option ";: Color 15: Input O1$
         If    O1$ = "1" then GoSub FileL
         If    O1$ = "2" then GoSub UseR
         If    O1$ = "3" then GoSub StatR
         If    O1$ = "4" then GoSub EomC
         If    O1$ = "5" then GoSub SaveF
         If    O1$ = "6" then GoSub InvAnl
         If    O1$ = "7" then Chain "CSINVUPD.EXE"
         Cls
         Color 10: Print "Do you wish to continue (Y or N) ";
         Color 15: Input A1$
         Cls
         If    A1$ = "Y" or A1$ = "y" then GoTo Main
         Close
         Locate 12,1: Color 4: Print "File Closed, Processing Complete": Color 15
         Lprint chr$(027);chr$(050);chr$(027);chr$(18)
         End
'------------------------------------------------------------------------------
OpenF:   Open  "R",1,F$,128
         Field #1, 2 as Z$, 8 as I$, 30 as D$, 2 as O$, 4 as V$, 4 as L$, 4 as C$
         For   I = 1 to 12 Step 1
               Field #1, (((I-1)*2)+54) as X1$, 2 as U$(I) '54 thru 77(0) X1$=Dummy
         Next  I
         Field #1, 78 as X1$, 2 as UO$, 2 as RO$, 4 as P$, 4 as CO$, 2 as R$
         Get   #1,1
         L1    = Cvi(Z$)
         If    L1 < 1 then L1 = 1
         I     = 1
         For   K = 2 to Lof(1)/128
               GoSub ReadF
               If Z$ <> "**" then GoTo OpenF.1
               I1$(I) = I$
               R1(I) = K
               I = I + 1
OpenF.1: Next  K
         M3    = I - 1
         Return
'------------------------------------------------------------------------------
ReadF:   Get   #1,K
         O     = Cvi(O$)
         V     = Cvs(V$)
         UO    = Cvi(UO$)
         P     = Cvs(P$)
         CO    = Cvs(CO$)
         RO    = Cvi(RO$)
         R     = Cvi(R$)
         For   J = 1 to 12 step 1
               U(J) = Cvi(U$(J))
         Next  J
         Return
'------------------------------------------------------------------------------
FindI:   K     = 0
         For   I = 1 to M3 Step 1
               If I9$ = I1$(I) then GoTo FI.1
         Next  I
         Color  4: Locate 25,1: Print "Item not Found";
         Color 15: Print "  Continue ";: Input G$
         Cls
         GoTo  FI.2
FI.1:    K     = R1(I)
FI.2:    Return
'------------------------------------------------------------------------------
WriteF:  For   J = 1 to 12 step 1
               Lset U$(J) = Mki$(U(J))
         Next  J
         Lset  UO$ = Mki$(UO)
         Lset  CO$ = Mks$(CO)
         Lset  RO$ = Mki$(RO)
         Put   #1,K
         Return
'------------------------------------------------------------------------------
'
'        File List
'
FileL:   GoSub   PosP
         GoSub   FileLT
         For     I = 1 to M3 step 1
                 K = R1(I)
                 GoSub ReadF
                 Lprint
                 Lprint "Item"; Tab(10);"Description"; Tab(41); "On-Hand"; Tab(50); "Item-Cost"; Tab(60); "Loc"; Tab(65); "Class"; Tab(72); "Cur-Use"; Tab(82); "Rcvd"; Tab(92); "Price"; Tab(102); "Cost-Goods"; Tab(114); "Reorder At"
                 Lprint
                 Lprint     I$; Tab(10);           D$; Tab(41);         O; Tab(50);           V; Tab(60);    L$; Tab(65);      C$; Tab(72);        UO; Tab(82);     RO; TAB(92);       P; Tab(102);           CO; Tab(114);           R
                 Lprint
                 Lprint  Tab(46); "Use for Previous Periods - Earliest First"
                 Lprint
                 For     J = 10 to 120 step 10
                         Lprint Using "##########"; Tab (J); U(J / 10);
                 Next    J
                 Lprint  String$(131,45)
                 Lin = Lin + 9
                 If Lin > 65 then GoSub FileLT
         Next    I
         Lprint  Chr$(12)
         GoTo    FileLE

FileLT:  Lprint  Chr$(12): Lprint  Tab(53); F$; "    As of: "; D1$
         Lprint
         Lprint  String$(131,45)
         Lin     = 3
FileLE:  Return
'-------------------------------------------------------------------------------
'
'        Use Report
'
UseR:    GoSub   PosP
         GoSub   UseRT
         For     I = 1 to M3 step 1
                 K = R1(I)
                 GoSub ReadF
                 Lprint
                 Lprint "Item"; Tab(10); "Cur-Use"; Tab(20); "Cost"; Tab(30); "On-Hand"; Tab(40); "Reorder At"
                 Lprint
                 Lprint     I$; Tab(10);        UO; Tab(20);     CO; Tab(30);         O; Tab(40);           R
                 Lprint
                 Lprint  Tab(46); "Use for Previous Periods - Earliest First"
                 Lprint
                 For     J = 10 to 120 step 10
                         Lprint Using "##########"; Tab (J); U(J / 10);
                 Next    J
                 Lprint  String$(131,45)
                 Lin = Lin + 9
                 If Lin > 65 then GoSub UseRT
         Next    I
         Lprint  Chr$(12)
         GoTo    UseE

UseRT:   Lprint  Chr$(12): Lprint  Tab(53); F$; " Use As of: "; D1$
         Lprint
         Lprint  String$(131,45)
         Lin     = 3
UseE:    Return
'-------------------------------------------------------------------------------
'
'        Use Report
'
StatR:   GoSub   PosP
         GoSub   StatRT
         For     I = 1 to M3 step 1
                 K = R1(I)
                 GoSub ReadF
                 Lprint I$; Tab(10); D$; Tab(42); O; Tab(50); V; Tab(60); R
                 Lin = Lin + 1
                 If Lin > 65 then GoSub StatRT
         Next    I
         Lprint  Chr$(12)
         GoTo    StatE

StatRT:  Lprint  Chr$(12): Lprint  Tab(50); F$; " Status As of: "; D1$
         Lprint
         Lprint  String$(131,45)
         Lprint
         Lprint "Item"; Tab(10); "Description"; Tab(42); "On-Hand"; Tab(50); "Avg-Cost"; Tab(60); "Reorder At"
         Lprint
         Lin     = 6
StatE:   Return
'-------------------------------------------------------------------------------
'
'        End of Month Close Out
'
EomC:    Locate  15,1: Color 4: Print "Do you want to ";
         Locate  15,16: Color 20: Print "CLOSE";
         Locate  15,22:  Color 4: Print "Accounts (Y or N) ";
         Locate  15,40: Color 15: Input A1$
         If      A1$ <> "Y" and A1$ <> "y" then GoTo EomCE
         GoSub   PosP
         Locate  15,1: Color 4: Print "***** Closing Inventory For Period *****";
         GoSub   EomCRT
         C1      = 0
         For     I = 1 to M3 step 1
                 K = R1(I)
                 GoSub ReadF
                 For J = 1 to 11 step 1
                     U(J) = U(J + 1)
                 Next J
                 U(12) = UO
                 Lprint I$; Tab(10); D$; Tab(42); U(12); Tab(50); CO
                 GoSub WriteF
                 C1 = C1 + CO
         Next    I
         Lprint
         Lprint  Tab(46); "Total Cost of Stock Used = "; Tab(74); C1
         Lprint  Chr$(12)
         GoTo    EomCE

EomCRT:  Lprint  Chr$(12): Lprint  Tab(43); F$; " Consumption at Closing As of: "; D1$
         Lprint
         Lprint  String$(131,45)
         Lprint
         Lprint "Item"; Tab(10); "Description"; Tab(42); "Usage"; Tab(50); "Cost"
         Lprint
         Lin     = 6
EomCE:   Return
'-------------------------------------------------------------------------------
'
'        Inventory Analysis
'
InvAnl:  Cls
         A1$     = ""
         Color   15: Print "***** Inventroy Analysis *****";
         Color   10:
         Locate  3,1: Print "1..All Items";
         Locate  4,1: Print "2..Items Below Reorder Point";
         Locate  6,1: Color 14: Print "Select Report: ";
         Locate  6,21:Color 6: Input A1$: Color 15
         GoSub   PosP
         GoSub   AnalH
         For     I = 1 to M3 step 1
                 K = R1(I)
                 GoSub ReadF
                 For J = 1 to 12 step 1
                     If U(I) <> 0 and X = 0 then X = 12 - I + 1
                     If X = 0 then GoTo AL1
                     A0 = A0 + U(I)
                     P9 = P9 + U(I)*I
                     C9 = C9 + I
AL1:             Next J
                 If X > 0 then A0 = INT(A0/X)
                 If X > 0 then P9 = INT(P9/C9)
                 If (A1$ = "2") and (O => R) then GoTo AL2
                 Lprint I$;Tab(10);D$;
                 Lprint using "#######"; Tab(41); UO;
                 Lprint using "#####.#"; Tab(51); A0;
                 Lprint using "#######"; Tab(65); O;
                 Lprint using "#######"; Tab(75); R;
                 Lprint using "#######"; Tab(83); P9
                 L0 = L0 + 1
                 X  = 0
                 P9 = 0
                 C9 = 0
                 A0 = 0
AL2:     Next    I
         Lprint
         Lprint  String$(131,45)
         Lprint
         Lprint  L0;" Records Printed"
         Return

AnalH:   Lprint  Chr$(12): Lprint  Tab(43); F$; " Inventory Analysis As of: "; D1$
         If      A1$ = "2" then Lprint Tab(49); "Items Below Reorder Point"
         If      A1$ <> "2" then Lprint
         Lprint  "Item"; Tab(10); "Description"; Tab(45); "Use"; Tab(55); "Avg"; Tab(65); "On-Hand"; Tab(75); "Reorder"; Tab(85); "Proj."
         Lprint  Tab(55); "Use"; Tab(75); " Point"; Tab(85); " Use"
         Lprint  String$(131,45)
         Lprint
         Lin     = 6
         Return
'-------------------------------------------------------------------------------
SaveF:   Cls
         Close   1
         Locate  3,1: Color 10: Print "Enter Save File Name: ";
         Locate  3,23: Color 15: Input F1$
         Open    "R",1,F$,128
         Open    "R",2,F1$,128
         Field   #1,128 as Z1$
         Field   #2,128 as Z2$
         For     K = 1 to Lof(1)/128
                 Get #1,K
                 Lset Z2$ = Z1$
                 Put #2,K
         Next    K
         Locate  5,1: Color 10: Print "File Saved as ";F1$
         Close   1,2
         GoSub   OpenF               ' Re_Open File
         Return
'-------------------------------------------------------------------------------
PosP:    Cls
         Locate  15,1: Color 20: Print "Position Forms";
         Locate  25,1: Color 15: Input G$
         Locate  15,1: Color 20: Print "Please Wait ! ";
         Return
